unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActiveX, WbemScripting_TLB, ComCtrls, ExtCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    bObtenerTodos: TButton;
    bObtenerParametro: TButton;
    txtParametro: TComboBox;
    txtClase: TComboBox;
    Panel1: TPanel;
    txtInfo: TRichEdit;
    Panel2: TPanel;
    Splitter1: TSplitter;
    bGuardar: TButton;
    dlGuardar: TSaveDialog;
    bLimpiar: TButton;
    txtPC: TEdit;
    Label3: TLabel;
    bSalir: TButton;
    Panel3: TPanel;
    StatusBar1: TStatusBar;
    LWEB: TLabel;
    procedure bObtenerTodosClick(Sender: TObject);
    procedure bObtenerParametroClick(Sender: TObject);
    procedure txtClaseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bLimpiarClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure bSalirClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

function GetWMIstring (wmiHost, wmiClass, wmiProperty : string) : string;
var
  Locator : ISWbemLocator;
  Services : ISWbemServices;
  SObject : ISWbemObject;
  ObjSet : ISWbemObjectSet;
  SProp : ISWbemProperty;
  Enum : IEnumVariant;
  Value : Cardinal;
  TempObj : OleVariant;
  SN : string;
begin
  try
    Locator := CoSWbemLocator.Create;
    //conectamos con el servicio WMI con root\cimv2
    Services :=  Locator.ConnectServer(wmiHost,
        'root\cimv2', '', '', '','', 0, nil);
    ObjSet := Services.ExecQuery('SELECT * FROM ' + wmiClass, 'WQL',
        wbemFlagReturnImmediately and wbemFlagForwardOnly , nil);
    Enum := (ObjSet._NewEnum) as IEnumVariant;
    while (Enum.Next(1, TempObj, Value) = S_OK) do
    begin
      SObject := IUnknown(tempObj) as ISWBemObject;
      SProp := SObject.Properties_.Item(wmiProperty, 0);
      if VarIsNull(SProp.Get_Value) then
        result := ''
      else
      begin
        SN := SProp.Get_Value;
        result :=  SN;
      end;
    end;
  except
    on exception do
      result := '';
  end;
end;


function obtenerAllDatosBIOS (wmiHost : string; clase : string) : string;
var
  consultaSQL : string;
var
  Item : SWbemObject;
  NumProp : LongWord;
  ObjectSet : ISWbemObjectSet;
  OleProperty : OleVariant;
begin
  consultaSQL := 'select * from ' + clase;
  ObjectSet := CoSWbemLocator.Create.ConnectServer(wmiHost,
      'root\cimv2', '', '', '', '', 0, nil ).ExecQuery(consultaSQL,
      'WQL', wbemFlagBidirectional, nil );
  if Succeeded((ObjectSet._NewEnum as IEnumVariant).Next(1,
      OleProperty, NumProp)) and (NumProp > 0)  and
      Succeeded(IDispatch(OleProperty).QueryInterface(
      SWBemObject, Item)) then
  begin
    Result := Item.GetObjectText_(0);
  end
  else
  begin
    Result := '<Desconocido>';
  end;
end;



procedure TformMenuPrincipal.bObtenerTodosClick(Sender: TObject);
begin
  txtInfo.Lines.Add (obtenerAllDatosBIOS (txtPC.Text, txtClase.Text));
end;

procedure TformMenuPrincipal.bObtenerParametroClick(Sender: TObject);
begin
  txtInfo.Lines.Add (getWMIstring(txtPC.Text, txtClase.Text, txtParametro.Text));
end;

procedure TformMenuPrincipal.txtClaseClick(Sender: TObject);
var
  fichero : string;
begin
  txtParametro.Clear;
  fichero := ExtractFilePath (Application.ExeName) + 'clases\' + txtClase.Text + '.txt';
  if FileExists(fichero) then
  begin
    txtParametro.Clear;
    txtParametro.Items.LoadFromFile (fichero);
  end;
end;



procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  fichero : string;
begin
  txtClase.Clear;
  fichero := ExtractFilePath (Application.ExeName) + '\clases\clases.txt';
  if FileExists(fichero) then
  begin
    txtClase.Clear;
    txtClase.Items.LoadFromFile (fichero);
  end;
end;

procedure TformMenuPrincipal.bLimpiarClick(Sender: TObject);
begin
  txtInfo.Clear;
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  if dlGuardar.Execute then
    txtInfo.Lines.SaveToFile(dlGuardar.FileName);
end;

procedure TformMenuPrincipal.bSalirClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
